#ifndef _BUFIO_H
#define _BUFIO_H

#include <stdio.h>

#define CBUFSIZE 4194304 // 4 MB 

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define MIN(a, b) (a < b ? a : b)

typedef struct {
	FILE * fp;
	char * buffer;
	char * bufpnt;
	int buflen;
	int inmem;
} CFILE;

/* bufio.c */
void init_cfile(CFILE *c);
int reminbuf(CFILE *c);
int cfload(CFILE *c, long offset);
CFILE *cfopen(const char *filename, char *mode);
size_t cfread(char *outbuf, size_t toread, CFILE *c);
int cfsetpos(CFILE *c, long pos);
int cfseek(CFILE *c, long offset, int whence);
long cftell(CFILE *c);
int cfeof(CFILE *c);
int cfclose(CFILE *c);

#endif
